#include <windows.h>
#include <stdlib.h>  		// for atol conversion  
#include "filters.h" 
#include "resource.h"

#include <vorbis/vorbisfile.h>

#define AVERAGESIZE 128

static	OggVorbis_File vf;

typedef struct output_tag  // any special vars associated with output file
	{short nFile;         
	 long lSize;
	 DWORD dwDataOffset;
	 long lSamprate;
	 WORD wBitsPerSample;
	 WORD wChannels;
	 DWORD dwFormat;
	 BOOL bWroteHeader;
	 char szNAME[256];
	} MYOUTPUT;

typedef struct input_tag // any special vars associated with input file
{	short nFile;
	long lSize;    
	DWORD dwFormat;  
	WORD wChannels;
	DWORD dwDataOffset;		   
	WORD wBitsPerSample;
	char szNAME[256];
} MYINPUT;


ogg_sync_state   oy; /* sync and verify incoming physical bitstream */
ogg_stream_state os; /* take physical pages, weld into a logical
						 stream of packets */
ogg_page         og; /* one Ogg bitstream page.  Vorbis packets are inside */
ogg_packet       op; /* one raw packet of data for decode */
						 
vorbis_info      *vi; /* struct that stores all the static vorbis bitstream
						  settings */
vorbis_comment   vc; /* struct that stores all the bitstream user comments */

BOOL WINAPI DllMain (HANDLE hModule, DWORD fdwReason, LPVOID lpReserved)
{
   switch (fdwReason)
   {
      case DLL_PROCESS_ATTACH:
        /* Code from LibMain inserted here.  Return TRUE to keep the
            DLL loaded or return FALSE to fail loading the DLL.
 
            You may have to modify the code in your original LibMain to
            account for the fact that it may be called more than once.
            You will get one DLL_PROCESS_ATTACH for each process that
            loads the DLL. This is different from LibMain which gets
            called only once when the DLL is loaded. The only time this
            is critical is when you are using shared data sections.
            If you are using shared data sections for statically
            allocated data, you will need to be careful to initialize it
            only once. Check your code carefully.
 
            Certain one-time initializations may now need to be done for
            each process that attaches. You may also not need code from
            your original LibMain because the operating system may now
            be doing it for you.
         */
         break;
 
      case DLL_THREAD_ATTACH:
         /* Called each time a thread is created in a process that has
            already loaded (attached to) this DLL. Does not get called
            for each thread that exists in the process before it loaded
            the DLL.
 
            Do thread-specific initialization here.
         */
         break;
 
      case DLL_THREAD_DETACH:
         /* Same as above, but called when a thread in the process
            exits.
 
            Do thread-specific cleanup here.
         */
         break;
 
      case DLL_PROCESS_DETACH:
         /* Code from _WEP inserted here.  This code may (like the
            LibMain) not be necessary.  Check to make certain that the
            operating system is not doing it for you.
         */
         break;
   }
 
   /* The return value is only used for DLL_PROCESS_ATTACH; all other
      conditions are ignored.  */
   return TRUE;   // successful DLL_PROCESS_ATTACH
}


// Fill COOLQUERY structure with information regarding this file filter

__declspec(dllexport) short FAR PASCAL QueryCoolFilter(COOLQUERY far * cq)
{   lstrcpy(cq->szName,"Ogg/Vorbis");		
	lstrcpy(cq->szCopyright,"Ogg/Vorbis Audio Format");
	lstrcpy(cq->szExt,"OGG"); 
	lstrcpy(cq->szExt2,""); 
	cq->lChunkSize=4096; 
	cq->dwFlags=QF_RATEADJUSTABLE|QF_CANLOAD;	//QF_CANSAVE|
 	cq->Stereo8=0xFF; // supports all rates of stereo 8
 	cq->Stereo16=0xFF;
 	cq->Stereo24=0xFF;
 	cq->Stereo32=0xFF;
 	cq->Mono8=0xFF; // supports all rates of stereo 8
 	cq->Mono16=0xFF;
 	cq->Mono24=0xFF;
 	cq->Mono32=0xFF;
 	cq->Quad32=0xFF;
 	cq->Quad16=0xFF;
 	cq->Quad8=0xFF;
 	return C_VALIDLIBRARY;
}

__declspec(dllexport) long FAR PASCAL FilterGetFileSize(HANDLE hInput)
{	


	__int64 size;
	

	sizea = ov_pcm_total( &vf, -1 ) ;
	sizea *= ov_info(&vf, -1)->channels;
	sizea *= 2 ; // sample size

	return sizea ;

}

__declspec(dllexport) BOOL FAR PASCAL FilterUnderstandsFormat(LPSTR filename)
{	short nFile;
	BOOL bUnderstands=FALSE;
	

	return TRUE ;

	nFile=_lopen(filename,OF_READ);
  	if (nFile!=-1)
  	{   char m[13];
  		DWORD dwDataOffset;
  		long lSize;
  		DWORD dwFormat;
  		
  		_lread(nFile,m,4);
  		m[4]=0x00;
  		if (lstrcmp(m,".snd")==0)
  		{
	  		_lread(nFile,&dwDataOffset,4);
	    	_lread(nFile,&lSize,4);
	    	_lread(nFile,&dwFormat,4);


	    	
	    	switch (dwFormat)
	    	{	case 1:
				case 27: 
				case 2:
				case 3:
			    	bUnderstands=TRUE;
					break;
			    default:
			    	break;
			}
    	}
    		
  		_lclose(nFile);
  	}	
  	
  	return bUnderstands;	
}


__declspec(dllexport) DWORD FAR PASCAL FilterGetOptions(HWND hWnd, HINSTANCE hInst, long lSamprate, WORD wChannels, WORD wBitsPerSample, DWORD dwOptions) // return 0 if no options box
{	long nDialogReturn=0L;
	FARPROC lpfnDIALOGMsgProc;
	lpfnDIALOGMsgProc = GetProcAddress(hInst,(LPCSTR)MAKELONG(20,0));			
			
	if (dwOptions==0)
		nDialogReturn=1;
	else
		nDialogReturn=dwOptions;
	
	if (nDialogReturn==3)  // 8-bit/16-bit linear, get 8/16 from original sample type
		nDialogReturn=2;
	
			
	nDialogReturn = (long)DialogBoxParam((HINSTANCE)hInst,(LPCSTR)MAKEINTRESOURCE(IDD_COMPRESSION), (HWND)hWnd, (DLGPROC)lpfnDIALOGMsgProc,nDialogReturn);
	
	return nDialogReturn;
}
__declspec(dllexport) DWORD FAR PASCAL FilterOptions(HANDLE hInput)
{   MYINPUT far *mi;
	DWORD options = 0;
    return options;
}	    

__declspec(dllexport) DWORD FAR PASCAL FilterOptionsString(HANDLE hInput, LPSTR szString)
{
	
	lstrcpy(szString,"Ogg Vorbis");

    return 1;
}

__declspec(dllexport) BOOL FAR PASCAL DIALOGMsgProc(HWND hWndDlg, UINT Message, WPARAM wParam, LPARAM lParam)
{switch(Message)
   {case WM_INITDIALOG:
         {	 long nDialogReturn;
         	 nDialogReturn=(long)lParam;
             
	         if (nDialogReturn==1)
	         {	CheckDlgButton(hWndDlg,IDC_LEVEL1,TRUE);
	         }
	         else if ((nDialogReturn==2) || (nDialogReturn==3))
	         {  CheckDlgButton(hWndDlg,IDC_LEVEL2,TRUE);
	         }
	         else if (nDialogReturn==27)
	         {	CheckDlgButton(hWndDlg,IDC_LEVEL3,TRUE);
	         }                          
	         else if (nDialogReturn==27)
	         {	CheckDlgButton(hWndDlg,IDC_LEVEL4,TRUE);
	         }	         
	         else if (nDialogReturn==27)
	         {	CheckDlgButton(hWndDlg,IDC_LEVEL5,TRUE);
	         }	         
	         else if (nDialogReturn==27)
	         {	CheckDlgButton(hWndDlg,IDC_LEVEL6,TRUE);
	         }	         
         }         
         break; /* End of WM_INITDIALOG                                 */

    case WM_CLOSE:
         /* Closing the Dialog behaves the same as Cancel               */
         PostMessage(hWndDlg, WM_COMMAND, IDCANCEL, 0L);
         break; /* End of WM_CLOSE                                      */

    case WM_COMMAND:
	{     switch(LOWORD(wParam))
           {case IDOK:
            	 {long nDialogReturn;
            	  if (IsDlgButtonChecked(hWndDlg,IDC_RADIO4))
            	  {	nDialogReturn=27;
            	  }
            	  else if (IsDlgButtonChecked(hWndDlg,IDC_RADIO2))
            	  {	nDialogReturn=2;
            	  }
            	  else
            	  {	nDialogReturn=1;
            	  }
            	  EndDialog(hWndDlg, (short)nDialogReturn);
            	 }
                 break;
            case IDCANCEL:
                 /* Ignore data values entered into the controls        */
                 /* and dismiss the dialog window returning FALSE       */
                 EndDialog(hWndDlg, FALSE);
                 break;
           }
         break;    /* End of WM_COMMAND                                 */
	}
    default:
        return FALSE;
   }
 return TRUE;
} /* End of DIALOGSMsgProc                                      */


__declspec(dllexport) DWORD FAR PASCAL FilterGetNextSpecialData(HANDLE hInput, SPECIALDATA * psp)
{	return 0; // only has 1 special data!  Otherwise we would use psp->hSpecialData
			  // as either a counter to know which item to retrieve next, or as a
			  // structure with other state information in it.
}

__declspec(dllexport) DWORD FAR PASCAL FilterGetFirstSpecialData(HANDLE hInput, 
	SPECIALDATA * psp)
{
	return 1;
}
    

__declspec(dllexport) DWORD FAR PASCAL FilterWriteSpecialData(HANDLE hOutput,
	LPCSTR szListType, LPCSTR szType, char * pData,DWORD dwSize)
{
	if ((lstrcmp(szListType,"INFO")==0) && (lstrcmp(szType,"INAM")==0))
	{	MYOUTPUT far *mo;
 		mo=(MYOUTPUT far *)GlobalLock(hOutput);
 		
		lstrcpy(mo->szNAME,pData);

 		GlobalUnlock(hOutput);
 		return 1;
	}	
	return 0;
}


 

__declspec(dllexport) HANDLE FAR PASCAL OpenFilterOutput(LPSTR lpstrFilename,long lSamprate,WORD wBitsPerSample,WORD wChannels,long lSize, long far *lpChunkSize, DWORD dwOptions)
{	HANDLE hOutput;
	short nFile;
	nFile=_lcreat(lpstrFilename,0);
	
	if (nFile==-1) return NULL;
    hOutput=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,sizeof(MYOUTPUT));
    if (hOutput)
    {	MYOUTPUT far *mo;
    	DWORD dw;
    	mo=(MYOUTPUT far *)GlobalLock(hOutput);
    	mo->nFile=nFile;
    	mo->lSize=lSize; // size in bytes 16-bit PCM
    	mo->lSamprate=lSamprate;
	 	mo->wBitsPerSample=wBitsPerSample;
	 	mo->wChannels=wChannels;
	 	dw=0x646e732e;
	 	_lwrite(mo->nFile,(LPCSTR)&dw,4);
	 	mo->dwFormat=dwOptions;
	 	FillMemory(mo->szNAME,255,0);
	 	
    	mo->bWroteHeader=FALSE;
    	//dw=0;
    	//_lwrite(mo->nFile,&dw,4);
		
    	GlobalUnlock(hOutput);		
    }

    *lpChunkSize=16384; 
	
    return hOutput;
}

__declspec(dllexport) void FAR PASCAL CloseFilterOutput(HANDLE hOutput)
{   if (hOutput)
	{	MYOUTPUT far *mo;
	 	mo=(MYOUTPUT far *)GlobalLock(hOutput);
	 	
	 	// Output actual number of bytes written
	 	
	 	if (mo->nFile!=-1)
	 	{	_lclose(mo->nFile);
	 		mo->nFile=-1;
	 	}        
	 	
	 	GlobalUnlock(hOutput);
	 	GlobalFree(hOutput);
	}
}              
  

__declspec(dllexport) DWORD FAR PASCAL WriteFilterOutput(HANDLE hOutput, unsigned char far *buf, long lBytes)
{
	DWORD written=0L;

}


// return handle that will be passed in to close, and write routines
__declspec(dllexport) HANDLE FAR PASCAL OpenFilterInput( LPSTR lpstrFilename,
											long far *lSamprate,
											WORD far *wBitsPerSample,
											WORD far *wChannels,
											HWND hWnd,
											long far *lChunkSize)
{	HANDLE hInput;
	short nFile;
	FILE *instream ;

	instream = fopen(lpstrFilename, "rb" );
	if ( instream <= 0 ) {
		return NULL ;
	}

	if ((ov_open (instream, &vf, NULL, 0)) < 0)
    {
		fclose( instream );

		return NULL;
    }

	vi = ov_info (&vf, -1);
    

    *lChunkSize = 4096;
    
	*wChannels =vi->channels;

	*wBitsPerSample = 16 ;

	*lSamprate = vi->rate ;

    return instream;
}

__declspec(dllexport) void FAR PASCAL CloseFilterInput(HANDLE hInput)
{ 
	ov_clear (&vf);

	if( hInput ) {
		fclose ( hInput );
	}

}

int current_section = -1;

__declspec(dllexport) DWORD FAR PASCAL ReadFilterInput(HANDLE hInput, unsigned char far *buf, long lBytes)
{
	int ret;

 	if (hInput)
	{

		ret = ov_read (&vf, buf, lBytes, 0, 2, 1, &current_section);    	    
 	}

 	return ret;	
}